/* vim: set ts=2 sw=2 sts=2 et: */

function PreselectFeedMappingController(base) {
    "use strict";
    this.callSupermethod('constructor', arguments);
    if (this.base && this.base.length) {
        this.init(base);
    }
}

// Extend from the base controller class
extend(PreselectFeedMappingController, AController);

// Extend the controller prototype with necessary properties and methods
jQuery.extend(PreselectFeedMappingController.prototype, (function () {

    "use strict";

    // Private variables
    var regexpColor = /".*color.*"/i,
        regexpSize = /".*size.*"/i;

    // Private methods
    // ...

    return {

        // Public properties

        name: 'PreselectFeedMappingController',
        findPattern: '.select-productfield .table-value',
        fields: {
            'googleshop-color-field-value':   regexpColor,
            'googleshop-size-field-value':    regexpSize,
            'ebaycomnet-color-field-value':   regexpColor,
            'ebaycomnet-size-field-value':    regexpSize,
            'pricegrabber-color-field-value': regexpColor,
            'pricegrabber-size-field-value':  regexpSize
        },

        // Public methods
        init: function (base) {

            var field = base.attr('class').substr(12),
                $button,
                regex = this.fields[field];

            if ('undefined' !== typeof(regex)) {
                $button = jQuery('<button class="btn regular-button btn-auto-feed-mapping">Select automatically</button>');
                base.append($button);
                $button.click(function (event) {
                    base.find('select option').each(function () {
                        if (regex.test(this.text)) {
                            this.selected = 'selected';
                        }
                    });
                    event.preventDefault();
                    event.stopPropagation();
                });
            }

        }

    }

}()));

core.autoload(PreselectFeedMappingController);